package main

import (
	"fmt"
	"io"
	"os"
	"os/exec"
	"regexp"
)

func main() {

	cmd := exec.Command("nix-locate", "--color=never", "lightningcss")
	out, err := cmd.CombinedOutput()
	if err != nil {
		panic(err)
	}

	re, err := regexp.Compile(`(?m)\/nix\/store\/[a-z0-9]+-lightningcss-[0-9.]+`)
	if err != nil {
		panic(err)
	}

	out = re.Find(out)
	outAsString := string(out)

	err = CopyFile(outAsString, "tools/lightningcss")
	if err != nil {
		panic(err)
	
	}

}

func CopyFile(src, dst string) error {

	srcFile, err := os.Open(src)
	if err != nil {
		return fmt.Errorf("failed to open source file: %v", err)
	}
	defer srcFile.Close()

	dstFile, err := os.Create(dst)
	if err != nil {
		return fmt.Errorf("failed to create destination file: %v", err)
	}
	defer dstFile.Close()

	_, err = io.Copy(dstFile, srcFile)
	if err != nil {
		return fmt.Errorf("failed to copy file content: %v", err)
	}

	err = dstFile.Sync()
	if err != nil {
		return fmt.Errorf("failed to sync destination file: %v", err)
	}

	return nil
}
